| OpenCV 3.4.3 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::SURF Class Referenceabstract
Extra 2D Features Framework » Non-free 2D Features Algorithms

Class for extracting Speeded Up Robust Features from an image [10] . More...

`#include "nonfree.hpp"`

Inheritance diagram for cv::xfeatures2d::SURF:

## Public Member Functions
virtual bool | getExtended () const =0
virtual double | getHessianThreshold () const =0
virtual int | getNOctaveLayers () const =0
virtual int | getNOctaves () const =0
virtual bool | getUpright () const =0
virtual void | setExtended (bool extended)=0
virtual void | setHessianThreshold (double hessianThreshold)=0
virtual void | setNOctaveLayers (int nOctaveLayers)=0
virtual void | setNOctaves (int nOctaves)=0
virtual void | setUpright (bool upright)=0
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant). More...
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant). More...
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty. More...
virtual String | getDefaultName () const CV_OVERRIDE
void | read (const String &fileName)
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage. More...
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual void | save (const String &filename) const
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< SURF > | create (double hessianThreshold=100, int nOctaves=4, int nOctaveLayers=3, bool extended=false, bool upright=false)
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class for extracting Speeded Up Robust Features from an image [10] .

The algorithm parameters:

- member int extended
  - 0 means that the basic descriptors (64 elements each) shall be computed
  - 1 means that the extended descriptors (128 elements each) shall be computed
- member int upright
  - 0 means that detector computes orientation of each feature.
  - 1 means that the orientation is not computed (which is much, much faster). For example, if you match images from a stereo pair, or do image stitching, the matched features likely have very similar angles, and you can speed up feature extraction by setting upright=1.
- member double hessianThreshold Threshold for the keypoint detector. Only features, whose hessian is larger than hessianThreshold are retained by the detector. Therefore, the larger the value, the less keypoints you will get. A good default value could be from 300 to 500, depending from the image contrast.
- member int nOctaves The number of a gaussian pyramid octaves that the detector uses. It is set to 4 by default. If you want to get very large features, use the larger value. If you want just small features, decrease it.
- member int nOctaveLayers The number of images within each octave of a gaussian pyramid. It is set to 2 by default.
  Note
    - An example using the SURF feature detector can be found at opencv_source_code/samples/cpp/generic_descriptor_match.cpp
      - Another example using the SURF feature detector, extractor and matcher can be found at opencv_source_code/samples/cpp/matcher_simple.cpp

## Member Function Documentation

## § create()

static Ptr<SURF> cv::xfeatures2d::SURF::create | ( | double | hessianThreshold = `100`,
|  | int | nOctaves = `4`,
|  | int | nOctaveLayers = `3`,
|  | bool | extended = `false`,
|  | bool | upright = `false`
| ) |  |
| static

Python:
| retval | = | cv.xfeatures2d.SURF_create( | [, hessianThreshold[, nOctaves[, nOctaveLayers[, extended[, upright]]]]] | )

Parameters

  hessianThreshold | Threshold for hessian keypoint detector used in SURF.
  nOctaves | Number of pyramid octaves the keypoint detector will use.
  nOctaveLayers | Number of octave layers within each octave.
  extended | Extended descriptor flag (true - use extended 128-element descriptors; false - use 64-element descriptors).
  upright | Up-right or rotated features flag (true - do not compute orientation of features; false - compute orientation).

## § getExtended()

virtual bool cv::xfeatures2d::SURF::getExtended | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_SURF.getExtended( |  | )

## § getHessianThreshold()

virtual double cv::xfeatures2d::SURF::getHessianThreshold | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_SURF.getHessianThreshold( |  | )

## § getNOctaveLayers()

virtual int cv::xfeatures2d::SURF::getNOctaveLayers | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_SURF.getNOctaveLayers( |  | )

## § getNOctaves()

virtual int cv::xfeatures2d::SURF::getNOctaves | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_SURF.getNOctaves( |  | )

## § getUpright()

virtual bool cv::xfeatures2d::SURF::getUpright | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_SURF.getUpright( |  | )

## § setExtended()

virtual void cv::xfeatures2d::SURF::setExtended | ( | bool | extended | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_SURF.setExtended( | extended | )

## § setHessianThreshold()

virtual void cv::xfeatures2d::SURF::setHessianThreshold | ( | double | hessianThreshold | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_SURF.setHessianThreshold( | hessianThreshold | )

## § setNOctaveLayers()

virtual void cv::xfeatures2d::SURF::setNOctaveLayers | ( | int | nOctaveLayers | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_SURF.setNOctaveLayers( | nOctaveLayers | )

## § setNOctaves()

virtual void cv::xfeatures2d::SURF::setNOctaves | ( | int | nOctaves | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_SURF.setNOctaves( | nOctaves | )

## § setUpright()

virtual void cv::xfeatures2d::SURF::setUpright | ( | bool | upright | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_SURF.setUpright( | upright | )

The documentation for this class was generated from the following file:

- /build/3_4-contrib_docs-lin64/opencv_contrib/modules/xfeatures2d/include/opencv2/xfeatures2d/nonfree.hpp